***This do file processes all original data to create the final dataset***
*REMEMBER to change your working directory to "Command Files" which is found within "Replication Documentation"*
***See read-me.docx for details as to how to appropriately change the working directory if you are unsure***
clear 
set more off 
pwd
import excel "../Original Data/2015_Contract_Data.xlsx", sheet("Sheet1") firstrow clear
***make a year variable, then save it***
gen yearsigned = 2015
save "../Original Data/2015_Contracts_w_year.xlsx", replace 
import excel "../Original Data/2014_Contract_Data.xlsx", sheet("Sheet1") firstrow clear
***make a year variable, then save it***
gen yearsigned = 2014
save "../Original Data/2014_Contracts_w_year.xlsx", replace
import excel "../Original Data/2013_Contract_Data.xlsx", sheet("Sheet1") firstrow clear 
***make a year variable, then save it***
gen yearsigned = 2013
save "../Original Data/2013_Contracts_w_year.xlsx", replace 
import excel "../Original Data/2012_Contract_Data.xlsx", sheet("Sheet1") firstrow clear 
***make a year variable, then save it***
gen yearsigned = 2012
save "../Original Data/2012_Contracts_w_year.xlsx", replace
***combine these data files into one full contract data file for 2013-2015***
append using "../Original Data/2013_Contracts_w_year.xlsx" "../Original Data/2014_Contracts_w_year.xlsx" "../Original Data/2015_Contracts_w_year.xlsx"
save "../Original Data/Final_Data.dta", replace
***drop unnecessary variables
drop if PLAYER=="PLAYER"
drop if missing(DOLLARS)
drop if DOLLARS=="--"
drop if DOLLARS=="Minor Lg" 
drop if TEAM=="--"
***only hitters***
drop if POS=="SP"
drop if POS=="RP"
drop if POS=="P"
drop if NEWTEAM=="--"
***make the dependent variable!!!***
destring(DOLLARS), generate(totalvalue)
destring(YRS), generate(length)
drop DOLLARS
drop YRS
generate avgannual = totalvalue/length
***make player year observations
egen ID = concat(PLAYER yearsigned), punct(" ") 
drop RK
rename PLAYER Name
drop if STATUS != "Signed" 
sort ID
save "../Original Data/Final_Data.dta", replace
***Import Race data
import excel "../Original Data/Player_Race.xlsx", sheet("Sheet1") firstrow clear
joinby Name using "../Original Data/Final_Data.dta", unmatched(none) 
duplicates drop 
gen lnavgannual = ln(avgannual) 
rename yearsigned year
save "../Analysis Data/Final_Data.dta", replace
***Race dummies***
generate Nonwhite = 0 
replace Nonwhite = 1 if Race == "B" | Race == "A" | Race == "H"
drop J
drop K
save "../Analysis Data/Final_Data.dta", replace 
erase "../Original Data/Final_Data.dta" 
erase "../Original Data/2015_Contracts_w_year.xlsx"
erase "../Original Data/2014_Contracts_w_year.xlsx"
erase "../Original Data/2013_Contracts_w_year.xlsx"
erase "../Original Data/2012_Contracts_w_year.xlsx"
***This section imports WAR data and makes an average of 3 previous years of WAR***
clear
set more off
***import 2015 WAR data***
import excel "../Original Data/IMPORTABLE_leagues_MLB_2015-value-batting_players_value_batting.xlsx", sheet("leagues_MLB_2015-value-batting_") firstrow
gen year = 2015
save "../Original Data/2015WarwithYear.xlsx", replace
***import 2014 WAR data***
import excel "../Original Data/IMPORTABLE_leagues_MLB_2014-value-batting_players_value_batting.xlsx", sheet("leagues_MLB_2014-value-batting_") firstrow clear
gen year = 2014
save "../Original Data/2014WarwithYear.xlsx", replace
***import 2013 WAR data***
import excel "../Original Data/IMPORTABLE_leagues_MLB_2013-value-batting_players_value_batting.xlsx", sheet("leagues_MLB_2013-value-batting_") firstrow clear
gen year = 2013
save "../Original Data/2013WarwithYear.xlsx", replace
***import 2012 WAR data***
import excel "../Original Data/IMPORTABLE_leagues_MLB_2012-value-batting_players_value_batting.xlsx", sheet("leagues_MLB_2012-value-batting_") firstrow clear
gen year = 2012
save "../Original Data/2012WarwithYear.xlsx", replace
***import 2011 WAR data***
import excel "../Original Data/IMPORTABLE_leagues_MLB_2011-value-batting_players_value_batting.xlsx", sheet("leagues_MLB_2011-value-batting_") firstrow clear
gen year = 2011
save "../Original Data/2011WarwithYear.xlsx", replace
***import 2010 WAR data***
import excel "../Original Data/IMPORTABLE_leagues_MLB_2010-value-batting_players_value_batting.xlsx", sheet("leagues_MLB_2010-value-batting_") firstrow clear
gen year = 2010
save "../Original Data/2010WarwithYear.xlsx", replace
***Append them all***
append using "../Original Data/2011WarwithYear.xlsx" "../Original Data/2012WarwithYear.xlsx" "../Original Data/2013WarwithYear.xlsx" "../Original Data/2014WarwithYear.xlsx" "../Original Data/2015WarwithYear.xlsx"
save "../Original Data/FinalWarData.dta", replace
erase "../Original Data/2010WarwithYear.xlsx" 
erase "../Original Data/2011WarwithYear.xlsx" 
erase "../Original Data/2012WarwithYear.xlsx" 
erase "../Original Data/2013WarwithYear.xlsx" 
erase "../Original Data/2014WarwithYear.xlsx" 
erase "../Original Data/2015WarwithYear.xlsx"
sort Name year
save "../Original Data/FinalWarData.dta", replace
***merge with contract data***
merge m:m Name year using "../Analysis Data/Final_Data.dta"
drop Rk Tm G PA Rbat Rbaser Rdp Rfield Rpos AGE RAA WAA Rrep RAR waaWL WL oWAR dWAR oRAR Salary Acquired PosSummary 
sort Name year
save "../Analysis Data/Contract_and_War_data.dta", replace
***make ID variable***
bysort Name: gen count=_n
bysort Name: egen max_year=max(year)
***sort Name and year***
sort Name year
***calculate an average WAR for every player in the dataset***
bysort Name: gen avg_war=(WAR[_n]+WAR[_n-1]+WAR[_n-2])/3 if count>2
bysort Name: replace avg_war=(WAR[_n]+WAR[_n-1])/2 if count==2
replace avg_war=WAR if count==1
***drop non 2012-2015 players***
drop if year==2010 | year==2011
***drop players that aren't in my dataset***
drop if missing(ID)
drop if Name == "Chris Young" 
drop if Name == "Corey Hart"
save "../Analysis Data/Final_Data.dta", replace 
